unit Unit1;

{ a simple program to generate a table of sequential prime numbers

  method:

  primes > 5 have the form 6K+1 or 6K+5, where  K = 1,2,3.....
  
  to inspect a number P to be prime:

  repeat
    divisor d = (6K+1) or d = (6K+5)     K = 1,2,3.........
    calculate P / d
    if remainder = 0, increment P by 4 (6K+1) or by 2 (6K+5), reset divisor to 5
     else increment d by 4 or by 2
  until quotient <= divisor
}


interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, shellapi;

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    PaintBox1: TPaintBox;
    Edit1: TEdit;
    Label1: TLabel;
    Image1: TImage;
    Label2: TLabel;
    procedure FormPaint(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PaintBox1Paint(Sender: TObject);
    procedure Label2MouseEnter(Sender: TObject);
    procedure Label2MouseLeave(Sender: TObject);
    procedure Label2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var P : cardinal=1;//prime number to investigate
    ip : byte;     //2,4 toggle for increment of P

procedure Clear;
//erase paintbox1
var i : byte;
    r : Trect;
begin
 with form1.PaintBox1 do with canvas do
  begin
   brush.Style := bsSolid;
   r.Left := 0;
   r.Right := width;
   for i := 0 to 24 do
    begin
     if i and 1 <> 0 then brush.Color := $e0ffff else brush.Color := $e0f0f0;
     r.Top := i *20;
     r.Bottom := r.top + 20;
     fillrect(r);
   end;//for
  end;//width
end;

procedure showprime(pp : cardinal; n : byte);
//paint pp at position n
//8 columns, 25 rows
var col,row : byte;
    x,y : integer;
    s : string;
begin
 col := n mod 8;
 row := n div 8;
 s := inttostr(pp);
 with form1.PaintBox1.Canvas do
  begin
   brush.Style := bsClear;
   x := (col+1)*100-textwidth(s)-5;
   y := row*20;
   textout(x,y,s);
  end; 
end;

procedure nextprimes;
//calculate the next 250 prime numbers
//p is last prime found
const p3 : array[0..2] of byte = (2,3,5); //first 3 primes
var n : byte;           //display position  0..249
    d : cardinal;       //divisor
    id : byte;          //divisor increment value
label nextP1,nextP2,nextD;
begin
 if p > 999900000 then
  begin
   showmessage('number too big'); //maximum of 9 digits fit on screen
   exit;
  end;

 Clear;                //clear paintbox
 n := 0;               //first number position
 if p < 8 then
  begin                //show primes 2,3,5
   for id := 0 to 2 do
    begin
     showprime(p3[id],n);
     inc(n);
    end;
   p := 7; //last prime
  end
 else
  case p mod 6 of         //adjust p to proper 6K+1 or 6K+5 multiple
   0 : inc(p);
   2 : inc(p,3);
   3 : inc(p,2);
   4 : inc(p);
  end;//case
 if P mod 3 = 1 then ip := 4 else ip := 2;

nextP2 :

 d := 5;                 //first divisor
 id := 2;                //divisor increment

nextD :

 if P mod d = 0 then goto nextP1;     //no prime

 if P div d > d then    //if not all divisors done
  begin
   d := d + id;         //inc d
   id := 6 - id;        //2..4 toggle
   goto nextD;
  end;

 if n = 0 then form1.Edit1.Text := inttostr(p);//set 1st prime in editbox
 showprime(p,n);
 inc(n);

nextP1 :

 P := P + ip;           //next number
 ip := 6 - ip;
 if n < 200 then goto nextP2;
end;

procedure TForm1.FormPaint(Sender: TObject);
//paint edge around paintbox
var x1,y1,x2,y2 : integer;
    i : byte;
begin
 with paintbox1 do
  begin
   x1 := Left-2; y1 := top-2;
   x2 := left + width + 1; y2 := top + height + 1;
  end;
 with canvas do
  begin
   pen.Width := 1;
   for i := 0 to 1 do
    begin
     pen.Color := 0;
     moveto(x2-i,y1+i);
     lineto(x1+i,y1+i);
     lineto(x1+i,y2-i);
     pen.Color := $707070;
     lineto(x2-i,y2-i);
     lineto(x2-i,y1+i);
    end;
  end;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
//generate next 250 primes
begin
 Nextprimes;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
//restart
begin
 p := 2;
 edit1.Text := '2';
 nextprimes;
end;

procedure TForm1.FormCreate(Sender: TObject);
//init main form
begin
 with paintbox1 do with canvas do
  begin
   left := 160;//image1.Left+image1.width+10;
   width := 800;
   top := 10;
   height := 500;
   font.Name := 'courier new';
   font.Height := 20;
   brush.Style := bsClear;
  end;
 width := paintbox1.left + paintbox1.Width + 20;
 clientheight := paintbox1.Top + paintbox1.Height + 20;
 bitbtn1.Top := paintbox1.Top+paintbox1.Height-bitbtn1.Height;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
//change attempt in first number
//filter non numeric codes
begin
 if not (key in ['0'..'9',#08]) then key := #0;
end;

procedure TForm1.Edit1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
//change attempt in firstnumber
begin
 if length(edit1.Text) = 0 then edit1.Text := '2';
 p := strtoint(edit1.Text);
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 clear;
 p:= strtoint(edit1.Text);
 nextprimes;
end;

procedure TForm1.Label2MouseEnter(Sender: TObject);
begin
 with label2.font do
  begin
   Color := $0000ff;
   style := [fsUnderline,fsBold];
  end;
end;

procedure TForm1.Label2MouseLeave(Sender: TObject);
begin
 with label2.font do
  begin
   Color := $ff0000;
   style := [fsBold];
  end;
end;

procedure TForm1.Label2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
//===
end;

procedure TForm1.Label2Click(Sender: TObject);
begin
 shellexecute(handle,'open',Pchar('http://www.davdata.nl/math/'),nil,nil,SW_SHOW);
end;

end.
